"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var path = require('path');

var fs = require('fs-extra');

var Obj2fsHOC = function Obj2fsHOC(WrappedObject) {
  return /*#__PURE__*/function (_WrappedObject) {
    (0, _inherits2["default"])(_class, _WrappedObject);

    var _super = _createSuper(_class);

    function _class() {
      (0, _classCallCheck2["default"])(this, _class);
      return _super.apply(this, arguments);
    }

    (0, _createClass2["default"])(_class, [{
      key: "setKey",
      // constructor() {
      //   super()
      // }
      // must call this function to attach object to store by key
      value: function setKey(key) {
        this.key = key;
        return this;
      }
      /* returns JSON String representation of the object */

    }, {
      key: "stringify",
      value: function stringify() {
        return JSON.stringify(this);
      }
      /* returns Object instance of a current class */

    }, {
      key: "parse",
      value: function parse(json) {
        var obj = JSON.parse(json);
        return Object.assign(this, obj);
      }
      /* store object in fs, key === file_name */

    }, {
      key: "store",
      value: function () {
        var _store = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
          var key, string;
          return _regenerator["default"].wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  key = this.key;
                  delete this.key; // key is transitent property, let's clear it before persisting to fs

                  string = this.stringify();
                  _context.next = 5;
                  return fs.outputFile(path.resolve(key), string);

                case 5:
                  this.key = key;
                  return _context.abrupt("return", string);

                case 7:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee, this);
        }));

        function store() {
          return _store.apply(this, arguments);
        }

        return store;
      }()
      /* retrieve object from fs, key === file_name */

    }, {
      key: "retrieve",
      value: function () {
        var _retrieve = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2() {
          var json;
          return _regenerator["default"].wrap(function _callee2$(_context2) {
            while (1) {
              switch (_context2.prev = _context2.next) {
                case 0:
                  if (fs.existsSync(path.resolve(this.key))) {
                    _context2.next = 2;
                    break;
                  }

                  throw new Error("No such key or file name found on disk");

                case 2:
                  _context2.next = 4;
                  return fs.readFile(path.resolve(this.key));

                case 4:
                  json = _context2.sent;
                  return _context2.abrupt("return", this.parse(json));

                case 6:
                case "end":
                  return _context2.stop();
              }
            }
          }, _callee2, this);
        }));

        function retrieve() {
          return _retrieve.apply(this, arguments);
        }

        return retrieve;
      }()
      /*  retrieve object from fs, key === file_name, or return new Object initialized with default constructor() */

    }, {
      key: "retrieveThrough",
      value: function () {
        var _retrieveThrough = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3() {
          var json;
          return _regenerator["default"].wrap(function _callee3$(_context3) {
            while (1) {
              switch (_context3.prev = _context3.next) {
                case 0:
                  if (fs.existsSync(path.resolve(this.key))) {
                    _context3.next = 3;
                    break;
                  }

                  _context3.next = 3;
                  return this.store();

                case 3:
                  _context3.next = 5;
                  return fs.readFile(path.resolve(this.key));

                case 5:
                  json = _context3.sent;
                  return _context3.abrupt("return", this.parse(json));

                case 7:
                case "end":
                  return _context3.stop();
              }
            }
          }, _callee3, this);
        }));

        function retrieveThrough() {
          return _retrieveThrough.apply(this, arguments);
        }

        return retrieveThrough;
      }()
    }]);
    return _class;
  }(WrappedObject);
};

var _default = Obj2fsHOC;
exports["default"] = _default;